Index: XIOS/dev/dev_trunk_omp/src/graphviz.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/graphviz.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/graphviz.cpp	(revision 1680)
@@ -72,35 +72,66 @@
     {
       CWorkflowGraph::buildStaticWorkflow_with_info();
+
+      StdString color_table[7] = {"black", "red", "blue", "green", "purple", "yellow", "gray"};
     
       std::ofstream fs_json;
       fs_json.open ("graph_data.json", std::fstream::out);
 
-      fs_json << "{ \"node\" : ["<<std::endl;
+      fs_json << "{\"nodes\":["<<std::endl<<"      ";
+      static bool firstnode=true;
+      static bool firstedge=true;
     
       for (auto it=CWorkflowGraph::mapFilters_ptr_with_info->begin(); it != CWorkflowGraph::mapFilters_ptr_with_info->end(); it++)
       {
-        fs_json << "        {\"id\": "<<it->first +1<<"}, "<<std::endl;
-        fs_json << "            {\"label\": \""<<it->second.filter_name<<"\"}, "<<std::endl  ;
-        fs_json << "            {\"class\": "<<it->second.filter_class<<"}, "<<std::endl  ;
-        fs_json << "            {\"filled\": "<<it->second.filter_filled<<"}, "<<std::endl  ;
-        fs_json << "            {\"entry\": "<<it->second.expected_entry_nb<<"}, "<<std::endl  ;
-        // fs_json << "            {\"date\": \""<<it->second.date<<"\"}, "<<std::endl  ;
-        fs_json << "            {\"type\": \""<<it->second.transform_type<<"\"}, "<<std::endl  ;
+        if(firstnode) 
+        {
+          fs_json << "{\"id\": "<<it->first +1<<", "<<std::endl;
+          firstnode = false;
+        }
+        else
+        {
+          fs_json << ",{\"id\": "<<it->first +1<<", "<<std::endl;
+        }
+        if(it->second.filter_class == 1) // source filter
+          fs_json << "       \"label\": \""<<it->second.filter_name<<"\\n("<<it->second.field_id<<")\", "<<std::endl;
+        else
+          fs_json << "       \"label\": \""<<it->second.filter_name<<"\", "<<std::endl;
+        fs_json << "       \"class\": \""<<it->second.filter_class<<"\", "<<std::endl;
+        fs_json << "       \"filled\": \""<<it->second.filter_filled<<"\", "<<std::endl;
+        fs_json << "       \"type\": \""<<it->second.transform_type<<"\", "<<std::endl;
+        fs_json << "       \"entry\": \""<<it->second.expected_entry_nb<<"\", "<<std::endl;
+        fs_json << "       \"inputs\": \""<<it->second.inputs_complete<<"\", "<<std::endl;
+        fs_json << "       \"tag\": \""<<it->second.filter_tag<<"\", "<<std::endl;
+        if(it->second.clusterID != -1) fs_json << "       \"cid\": \""<<it->second.clusterID<<"\", "<<std::endl;
+        fs_json << "       \"attributes\": \""<<it->second.attributes<<"\"}"<<std::endl<<"      ";
       }
-      fs_json << "    ]}"<<std::endl<<std::endl;
-
-      fs_json << "{ \"edge\" : ["<<std::endl;
+      fs_json << "    ],"<<std::endl;
+
+
+      fs_json << " \"edges\" : ["<<std::endl<<"      ";
 
       for (auto it=CWorkflowGraph::mapFieldToFilters_ptr_with_info->begin(); it != CWorkflowGraph::mapFieldToFilters_ptr_with_info->end(); it++)
       {
-        fs_json << "        {\"id\": "<<it->first +1<<"}, "<<std::endl;
-        fs_json << "            {\"from\": "<<it->second.from +1<<"}, "<<std::endl;
-        fs_json << "            {\"to\": "<<it->second.to+1<<"}, "<<std::endl  ;
-        fs_json << "            {\"fid\": \""<<it->second.field_id<<"\"}, "<<std::endl  ;
-        fs_json << "            {\"fname\": \""<<it->second.field_name<<"\"}, "<<std::endl  ;
-        fs_json << "            {\"gid\": \""<<it->second.grid_id<<"\"}, "<<std::endl  ;
-        fs_json << "            {\"date\": \""<<it->second.date<<"\"}, "<<std::endl  ;
+        if(firstedge)
+        {
+          fs_json << "{\"id\": "<<it->first +1<<", "<<std::endl;
+          firstedge = false;
+        }
+        else
+        {
+          fs_json << ",{\"id\": "<<it->first +1<<", "<<std::endl;
+        }
+        fs_json << "       \"from\": "<<it->second.from+1<<", "<<std::endl;
+        fs_json << "       \"to\": "<<it->second.to+1<<", "<<std::endl;
+        fs_json << "       \"label\": \""<<it->second.field_id<<"\\n"<<it->second.date<<"\", "<<std::endl;
+        // fs_json << "       \"title\": \""<<"Show more information about this field"<<"\", "<<std::endl;
+        // fs_json << "       \"fid\": \""<<it->second.field_id<<"\", "<<std::endl;
+        // fs_json << "       \"fname\": \""<<it->second.field_name<<"\", "<<std::endl;
+        // fs_json << "       \"gid\": \""<<it->second.grid_id<<"\", "<<std::endl;
+        fs_json << "       \"date\": \""<<it->second.date<<"\", "<<std::endl;
+        fs_json << "       \"attributes\": \"id = "<<it->second.field_id<<"</br>"<<it->second.attributes<<"\"}"<<std::endl<<"      ";
+
       }
-      fs_json << "    ]}"<<std::endl<<std::endl;
+      fs_json << "    ]}"<<std::endl;
 
 
@@ -114,65 +145,68 @@
 
 
-      std::ofstream fs;
-      fs.open ("graph_with_info.html", std::fstream::out);
-
-      fs << "<html>" <<std::endl;
-      fs << "<head>" <<std::endl;
-      fs << "    <script type=\"text/javascript\" src=\"../../../vis-4.21.0/dist/vis.js\"></script>" <<std::endl;
-      fs << "    <link href=\"../../../vis-4.21.0/dist/vis.css\" rel=\"stylesheet\" type=\"text/css\" />" <<std::endl <<std::endl;
-      fs << "    <style type=\"text/css\">"<<std::endl;
-      fs << "        #mynetwork {"<<std::endl;
-      fs << "            width: 1000px;"<<std::endl;
-      fs << "            height: 800px;"<<std::endl;
-      fs << "            border: 1px solid lightgray"<<std::endl;
-      fs << "        }"<<std::endl;
-      fs << "    </style>"<<std::endl;
-      fs << "</head>"<<std::endl;
-      fs << "<body>"<<std::endl;
-      fs << "<div id=\"mynetwork\"></div>"<<std::endl<<std::endl;
-      fs << "<script type=\"text/javascript\">"<<std::endl;
-
-      fs << "    var nodes = new vis.DataSet(["<<std::endl;
-      for(int i=0; i<CWorkflowGraph::filters.size(); i++)
-      {
-        fs << "        {id: "<<i+1<<", label: \'"<<CWorkflowGraph::filters[i]<<"\'},"<<std::endl  ;
-      }
-      fs << "    ]);"<<std::endl<<std::endl;
-
-
-      fs << "    var edges = new vis.DataSet(["<<std::endl;
-      for(int i=0; i<CWorkflowGraph::fieldsToFilters.size(); i++)
-      {
-        fs <<"        {from: "<<CWorkflowGraph::fieldsToFilters[i].first+1<<", to: "<<CWorkflowGraph::fieldsToFilters[i].second+1<<", label: \'"<<CWorkflowGraph::fields[i]<<"\'},"<<std::endl;
-      }
-      fs << "    ]);"<<std::endl<<std::endl;
+      // std::ofstream fs;
+      // fs.open ("graph_with_info.html", std::fstream::out);
+
+      // fs << "<html>" <<std::endl;
+      // fs << "<head>" <<std::endl;
+      // fs << "    <script type=\"text/javascript\" src=\"../../../vis-4.21.0/dist/vis.js\"></script>" <<std::endl;
+      // fs << "    <link href=\"../../../vis-4.21.0/dist/vis.css\" rel=\"stylesheet\" type=\"text/css\" />" <<std::endl <<std::endl;
+      // fs << "    <style type=\"text/css\">"<<std::endl;
+      // fs << "        #mynetwork {"<<std::endl;
+      // fs << "            width: 1000px;"<<std::endl;
+      // fs << "            height: 800px;"<<std::endl;
+      // fs << "            border: 1px solid lightgray"<<std::endl;
+      // fs << "        }"<<std::endl;
+      // fs << "    </style>"<<std::endl;
+      // fs << "</head>"<<std::endl;
+      // fs << "<body>"<<std::endl;
+      // fs << "<div id=\"mynetwork\"></div>"<<std::endl<<std::endl;
+      // fs << "<script type=\"text/javascript\">"<<std::endl;
+
+      // fs << "    var nodes = new vis.DataSet(["<<std::endl;
+      // for(int i=0; i<CWorkflowGraph::filters.size(); i++)
+      // {
+      //   StdString color_table[7] = {"black", "red", "blue", "green", "purple", "yellow", "gray"};
+
+      //   fs << "        {id: "<<i+1<<", label: \'"<<CWorkflowGraph::filters[i]<<"\', title: \'"<<"Show more information about this filter"<<"\'";
+      //   fs <<", color: \'"<<color_table[(*CWorkflowGraph::mapFilters_ptr_with_info)[i].filter_class]<<"\'},"<<std::endl  ;
+      // }
+      // fs << "    ]);"<<std::endl<<std::endl;
+
+
+      // fs << "    var edges = new vis.DataSet(["<<std::endl;
+      // for(int i=0; i<CWorkflowGraph::fieldsToFilters.size(); i++)
+      // {
+      //   fs <<"        {from: "<<CWorkflowGraph::fieldsToFilters[i].first+1<<", to: "<<CWorkflowGraph::fieldsToFilters[i].second+1<<", label: \'"<<CWorkflowGraph::fields[i]<<"\', title: \'"<<"Show more information about this field"<<"\'},"<<std::endl  ;
+      // }
+      // fs << "    ]);"<<std::endl<<std::endl;
 
   
-      fs << "    var container = document.getElementById(\'mynetwork\');" <<std::endl<<std::endl;
-      fs << "    var data = {" <<std::endl;
-      fs << "        nodes: nodes," <<std::endl;
-      fs << "        edges: edges" <<std::endl;
-      fs << "    };" <<std::endl;
-      fs << "    var options = {"<<std::endl;
-      fs << "        edges:{"<<std::endl;
-      fs << "            smooth: false,"<<std::endl;
-      fs << "            arrows: \'to\',"<<std::endl;
-      fs << "            color: 'red',"<<std::endl;
-      fs << "            font:{align: \'middle\'},"<<std::endl;
-      fs << "        },"<<std::endl;
-      fs << "        physics:{"<<std::endl;
-      fs << "            enabled: false,"<<std::endl;
-      fs << "        },"<<std::endl;
-      fs << "};" <<std::endl<<std::endl;
-
-      fs << "    var network = new vis.Network(container, data, options);" <<std::endl<<std::endl;
-
-      fs << "</script>"<<std::endl;
-      fs << "</body>"<<std::endl;
-      fs << "</html>"<<std::endl;
+      // fs << "    var container = document.getElementById(\'mynetwork\');" <<std::endl<<std::endl;
+      // fs << "    var data = {" <<std::endl;
+      // fs << "        nodes: nodes," <<std::endl;
+      // fs << "        edges: edges" <<std::endl;
+      // fs << "    };" <<std::endl;
+      // fs << "    var options = {"<<std::endl;
+      // fs << "        edges:{"<<std::endl;
+      // fs << "            smooth: false,"<<std::endl;
+      // fs << "            arrows: \'to\',"<<std::endl;
+      // fs << "            color: 'red',"<<std::endl;
+      // fs << "            font:{align: \'middle\'},"<<std::endl;
+      // fs << "        },"<<std::endl;
+      // fs << "        physics:{"<<std::endl;
+      // fs << "            enabled: false,"<<std::endl;
+      // fs << "        },"<<std::endl;
+      // fs << "};" <<std::endl<<std::endl;
+
+      // fs << "    var network = new vis.Network(container, data, options);" <<std::endl<<std::endl;
+
+      // fs << "</script>"<<std::endl;
+      // fs << "</body>"<<std::endl;
+      // fs << "</html>"<<std::endl;
 
       
 
-      fs.close();
+      // fs.close();
          
     }
Index: XIOS/dev/dev_trunk_omp/src/node/field.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/node/field.cpp	(revision 1680)
@@ -922,4 +922,5 @@
    TRY
    {
+
      CContext* context = CContext::getCurrent();
      bool hasClient = context->hasClient;
@@ -1200,5 +1201,4 @@
            {
              CField* fieldRef = CField::get(field_ref);
-             fieldRef->build_workflow_graph.setValue(buildWorkflowGraph);
              CGrid* gridRef = fieldRef->grid;
 
@@ -1236,5 +1236,4 @@
          else if (!field_ref.isEmpty())
          {
-           CField::get(field_ref)->build_workflow_graph.setValue(buildWorkflowGraph);
            instantDataFilter = getFieldReference(gc);
            instantDataFilter->tag = buildWorkflowGraph;
@@ -1297,5 +1296,5 @@
            fileWriterFilter->end_graph = filter_end;
 
-           std::cout<<"CFileWriterFilter filter start = "<<filter_start<<" end = "<<filter_end<<std::endl;
+           // std::cout<<"CFileWriterFilter filter start = "<<filter_start<<" end = "<<filter_end<<" field = "<<this->getId()<<std::endl;
 
          }
@@ -1368,5 +1367,5 @@
        filters.second->parent_filters[0]= fieldRef->getInstantDataFilter();
 
-       filters.second->tag = buildWorkflowGraph || filters.second->parent_filters[0]->tag;
+       filters.second->tag = (buildWorkflowGraph || filters.second->parent_filters[0]->tag);
 
        filters.second->start_graph = filter_start;
@@ -1528,5 +1527,5 @@
 
        const bool detectMissingValues = (!detect_missing_value.isEmpty() && detect_missing_value == true);
-       bool buildWorkflowGraph = buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
+       bool buildWorkflowGraph = (!build_workflow_graph.isEmpty() && build_workflow_graph == true);
        std::shared_ptr<CTemporalFilter> temporalFilter(new CTemporalFilter(gc, operation,
                                                                            CContext::getCurrent()->getCalendar()->getInitDate(),
Index: XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/parse_expr/filter_expr_node.cpp	(revision 1680)
@@ -106,9 +106,17 @@
   std::shared_ptr<COutputPin> CFilterUnaryOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch = child->reduce(gc, thisField);
+
     std::shared_ptr<CUnaryArithmeticFilter> filter(new CUnaryArithmeticFilter(gc, opId));
-    child->reduce(gc, thisField)->connectOutput(filter, 0);
-
-    (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child->reduce(gc, thisField);
+    ch->connectOutput(filter, 0);
+
+    (filter->parent_filters).resize(1);
+    (filter->parent_filters)[0] = ch;
+
+    filter->tag = ch->tag;
+    filter->start_graph = ch->start_graph;
+    filter->end_graph = ch->end_graph;
+    filter->field = &thisField;
+
 
     return filter;
@@ -127,9 +135,15 @@
   std::shared_ptr<COutputPin> CFilterScalarFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
     std::shared_ptr<CScalarFieldArithmeticFilter> filter(new CScalarFieldArithmeticFilter(gc, opId, child1->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
+    ch2->connectOutput(filter, 0);
     
     (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child2->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch2;
+
+    filter->tag = ch2->tag;
+    filter->start_graph = ch2->start_graph;
+    filter->end_graph = ch2->end_graph;
+    filter->field = &thisField;
 
     return filter;
@@ -148,9 +162,17 @@
   std::shared_ptr<COutputPin> CFilterFieldScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+
     std::shared_ptr<CFieldScalarArithmeticFilter> filter(new CFieldScalarArithmeticFilter(gc, opId, child2->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-
-    (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
+    ch1->connectOutput(filter, 0);
+
+    (filter->parent_filters).resize(1);
+    (filter->parent_filters)[0] = ch1;
+
+    filter->tag = ch1->tag;
+    filter->start_graph = ch1->start_graph;
+    filter->end_graph = ch1->end_graph;
+    filter->field = &thisField;
+
     return filter;
   }
@@ -168,11 +190,21 @@
   std::shared_ptr<COutputPin> CFilterFieldFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
+
     std::shared_ptr<CFieldFieldArithmeticFilter> filter(new CFieldFieldArithmeticFilter(gc, opId));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1); 
+    ch1->connectOutput(filter, 0);
+    ch2->connectOutput(filter, 1); 
 
     (filter->parent_filters).resize(2);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
-    (filter->parent_filters)[1] = child2->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch1;
+    (filter->parent_filters)[1] = ch2;
+
+    filter->tag = (ch1->tag || ch2->tag);
+    filter->start_graph = ch1->tag? ch1->start_graph : (ch2->tag? ch2->start_graph: -1);
+    filter->end_graph = ch1->tag? ch1->end_graph : (ch2->tag? ch2->end_graph: -1);
+    filter->field = &thisField;
+
+
     return filter;
   }
@@ -194,9 +226,16 @@
   std::shared_ptr<COutputPin> CFilterScalarScalarFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch3 = child3->reduce(gc, thisField);
+
     std::shared_ptr<CScalarScalarFieldArithmeticFilter> filter(new CScalarScalarFieldArithmeticFilter(gc, opId, child1->reduce(),child2->reduce()));
-    child3->reduce(gc, thisField)->connectOutput(filter, 0);
+    ch3->connectOutput(filter, 0);
     
     (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child3->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch3;
+
+    filter->tag = ch3->tag;
+    filter->start_graph = ch3->start_graph;
+    filter->end_graph = ch3->end_graph;
+    filter->field = &thisField;
 
     return filter;
@@ -217,9 +256,17 @@
   std::shared_ptr<COutputPin> CFilterScalarFieldScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
+
     std::shared_ptr<CScalarFieldScalarArithmeticFilter> filter(new CScalarFieldScalarArithmeticFilter(gc, opId, child1->reduce(),child3->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
-
-    (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child2->reduce(gc, thisField);
+    ch2->connectOutput(filter, 0);
+
+    (filter->parent_filters).resize(1);
+    (filter->parent_filters)[0] = ch2;
+
+    filter->tag = ch2->tag;
+    filter->start_graph = ch2->start_graph;
+    filter->end_graph = ch2->end_graph;
+    filter->field = &thisField;
+
     return filter;
   }
@@ -239,11 +286,19 @@
   std::shared_ptr<COutputPin> CFilterScalarFieldFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch3 = child3->reduce(gc, thisField);
+
     std::shared_ptr<CScalarFieldFieldArithmeticFilter> filter(new CScalarFieldFieldArithmeticFilter(gc, opId, child1->reduce()));
-    child2->reduce(gc, thisField)->connectOutput(filter, 0);
-    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    ch2->connectOutput(filter, 0);
+    ch3->connectOutput(filter, 1);
 
     (filter->parent_filters).resize(2);
-    (filter->parent_filters)[0] = child2->reduce(gc, thisField);
-    (filter->parent_filters)[1] = child3->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch2;
+    (filter->parent_filters)[1] = ch3;
+
+    filter->tag = (ch3->tag || ch2->tag);
+    filter->start_graph = ch3->tag? ch3->start_graph : (ch2->tag? ch2->start_graph: -1);
+    filter->end_graph = ch3->tag? ch3->end_graph : (ch2->tag? ch2->end_graph: -1);
+    filter->field = &thisField;
 
     return filter;
@@ -265,9 +320,17 @@
   std::shared_ptr<COutputPin> CFilterFieldScalarScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+
     std::shared_ptr<CFieldScalarScalarArithmeticFilter> filter(new CFieldScalarScalarArithmeticFilter(gc, opId, child2->reduce(),child3->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-
-    (filter->parent_filters).resize(1);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
+    ch1->connectOutput(filter, 0);
+
+    (filter->parent_filters).resize(1);
+    (filter->parent_filters)[0] = ch1;
+
+    filter->tag = ch1->tag;
+    filter->start_graph = ch1->start_graph;
+    filter->end_graph = ch1->end_graph;
+    filter->field = &thisField;
+
     return filter;
   }
@@ -288,11 +351,19 @@
   std::shared_ptr<COutputPin> CFilterFieldScalarFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch3 = child3->reduce(gc, thisField);
+
     std::shared_ptr<CFieldScalarFieldArithmeticFilter> filter(new CFieldScalarFieldArithmeticFilter(gc, opId, child2->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child3->reduce(gc, thisField)->connectOutput(filter, 1);
+    ch1->connectOutput(filter, 0);
+    ch3->connectOutput(filter, 1);
 
     (filter->parent_filters).resize(2);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
-    (filter->parent_filters)[1] = child3->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch1;
+    (filter->parent_filters)[1] = ch3;
+
+    filter->tag = (ch3->tag || ch1->tag);
+    filter->start_graph = ch3->tag? ch3->start_graph : (ch1->tag? ch1->start_graph: -1);
+    filter->end_graph = ch3->tag? ch3->end_graph : (ch1->tag? ch1->end_graph: -1);
+    filter->field = &thisField;
 
     return filter;
@@ -314,11 +385,19 @@
   std::shared_ptr<COutputPin> CFilterFieldFieldScalarOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
+
     std::shared_ptr<CFieldFieldScalarArithmeticFilter> filter(new CFieldFieldScalarArithmeticFilter(gc, opId, child3->reduce()));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1);
+    ch1->connectOutput(filter, 0);
+    ch2->connectOutput(filter, 1);
 
     (filter->parent_filters).resize(2);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
-    (filter->parent_filters)[1] = child2->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch1;
+    (filter->parent_filters)[1] = ch2;
+
+    filter->tag = (ch2->tag || ch1->tag);
+    filter->start_graph = ch2->tag? ch2->start_graph : (ch1->tag? ch1->start_graph: -1);
+    filter->end_graph = ch2->tag? ch2->end_graph : (ch1->tag? ch1->end_graph: -1);
+    filter->field = &thisField;
     return filter;
   }
@@ -338,13 +417,25 @@
   std::shared_ptr<COutputPin> CFilterFieldFieldFieldOpExprNode::reduce(CGarbageCollector& gc, CField& thisField) const
   {
+    std::shared_ptr<COutputPin> ch1 = child1->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch2 = child2->reduce(gc, thisField);
+    std::shared_ptr<COutputPin> ch3 = child3->reduce(gc, thisField);
+
     std::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId));
-    child1->reduce(gc, thisField)->connectOutput(filter, 0);
-    child2->reduce(gc, thisField)->connectOutput(filter, 1);
-    child3->reduce(gc, thisField)->connectOutput(filter, 2);
+    std::cout<<"std::shared_ptr<CFieldFieldFieldArithmeticFilter> filter(new CFieldFieldFieldArithmeticFilter(gc, opId))" <<std::endl;
+    ch1->connectOutput(filter, 0);
+    ch2->connectOutput(filter, 1);
+    ch3->connectOutput(filter, 2);
 
     (filter->parent_filters).resize(3);
-    (filter->parent_filters)[0] = child1->reduce(gc, thisField);
-    (filter->parent_filters)[1] = child2->reduce(gc, thisField);
-    (filter->parent_filters)[2] = child3->reduce(gc, thisField);
+    (filter->parent_filters)[0] = ch1;
+    (filter->parent_filters)[1] = ch2;
+    (filter->parent_filters)[2] = ch3;
+
+
+    filter->tag = (ch1->tag || ch1->tag || ch3->tag);
+    filter->start_graph = ch1->tag? ch1->start_graph : (ch2->tag? ch2->start_graph: (ch3->tag? ch3->start_graph: -1));
+    filter->end_graph = ch1->tag? ch1->end_graph : (ch2->tag? ch2->end_graph: (ch3->tag? ch3->end_graph: -1));
+    filter->field = &thisField;
+
 
     return filter;
Index: XIOS/dev/dev_trunk_omp/src/parse_expr/yacc_parser.cpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/parse_expr/yacc_parser.cpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/parse_expr/yacc_parser.cpp	(revision 1680)
@@ -70,4 +70,6 @@
 #include "exception.hpp"
 
+#include "yacc_var.hpp"
+
 using namespace std;
 using namespace xios;
@@ -86,6 +88,13 @@
   #pragma omp threadprivate(parsed, globalInputText_ptr, globalReadOffset)
 
+  
+  std::string *xios::yacc_globalInputText_ptr = 0;
+  // #pragma omp threadprivate(xios::yacc_globalInputText_ptr)
+
   int readInputForLexer(char* buffer, size_t* numBytesRead, size_t maxBytesToRead)
   {
+    yacc_globalInputText_ptr = globalInputText_ptr;
+
+    std::cout<<"========= yacc_globalInputText_ptr = "<<*yacc_globalInputText_ptr<<std::endl;
     if(globalInputText_ptr == 0) globalInputText_ptr = new std::string;
     size_t numBytesToRead = maxBytesToRead;
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_duplicate_scalar.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_duplicate_scalar.hpp	(revision 1680)
@@ -33,4 +33,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Duplicate Scalar";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract.hpp	(revision 1680)
@@ -27,4 +27,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Extract";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_extract_domain.hpp	(revision 1680)
@@ -40,4 +40,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Extract Domain";}
+
 protected:
   enum ExtractDirection {
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_interpolate.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_interpolate.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_interpolate.hpp	(revision 1680)
@@ -32,4 +32,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Interpolation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_inverse.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_inverse.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_inverse.hpp	(revision 1680)
@@ -31,4 +31,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Inverse";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_axis.hpp	(revision 1680)
@@ -40,4 +40,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Axis";}
 protected:
   
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_reduce_domain.hpp	(revision 1680)
@@ -41,4 +41,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Reduce Domain";}
+
 protected:
   enum ReduceDirection {
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_temporal_splitting.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_temporal_splitting.hpp	(revision 1680)
@@ -34,4 +34,6 @@
   static bool registerTrans();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Temporal Splitting";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_transformation.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_transformation.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_transformation.hpp	(revision 1680)
@@ -31,4 +31,6 @@
   virtual ~CAxisAlgorithmTransformation();
 
+  virtual StdString getName() {return "Axis Trans. Filter \\n Transformation";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_zoom.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_zoom.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/axis_algorithm_zoom.hpp	(revision 1680)
@@ -27,4 +27,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Axis Trans. Filter \\n Zoom";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_compute_connectivity.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_compute_connectivity.hpp	(revision 1680)
@@ -28,4 +28,7 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Compute Connectivity";}
+
 protected:
   void computeIndexSourceMapping_(const std::vector<CArray<double,1>* >& dataAuxInputs);
Index: XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_expand.hpp
===================================================================
--- XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_expand.hpp	(revision 1679)
+++ XIOS/dev/dev_trunk_omp/src/transformation/domain_algorithm_expand.hpp	(revision 1680)
@@ -28,4 +28,6 @@
 
   static bool registerTrans();
+
+  virtual StdString getName() {return "Domain Trans. Filter \\n Expand";}
 
 protected:
